var __classPrivateFieldSet = (this && this.__classPrivateFieldSet) || function (receiver, state, value, kind, f) {
    if (kind === "m") throw new TypeError("Private method is not writable");
    if (kind === "a" && !f) throw new TypeError("Private accessor was defined without a setter");
    if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver)) throw new TypeError("Cannot write private member to an object whose class did not declare it");
    return (kind === "a" ? f.call(receiver, value) : f ? f.value = value : state.set(receiver, value)), value;
};
var __classPrivateFieldGet = (this && this.__classPrivateFieldGet) || function (receiver, state, kind, f) {
    if (kind === "a" && !f) throw new TypeError("Private accessor was defined without a getter");
    if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver)) throw new TypeError("Cannot read private member from an object whose class did not declare it");
    return kind === "m" ? f : kind === "a" ? f.call(receiver) : f ? f.value : state.get(receiver);
};
var _AppCheckToken_native, _AppCheckProviderFactory_native, _AppCheckProvider_native, _AppCheck_native, _AppCheck_nativeApp, _AppCheck_app;
import { firebase, FirebaseApp, FirebaseError } from '@nativescript/firebase-core';
import { Device } from '@nativescript/core';
let defaultAppCheck;
const fb = firebase();
Object.defineProperty(fb, 'appCheck', {
    value: (app) => {
        if (!app) {
            if (!defaultAppCheck) {
                defaultAppCheck = new AppCheck();
            }
            return defaultAppCheck;
        }
        return new AppCheck(app);
    },
    writable: false,
});
export class AppCheckToken {
    constructor() {
        _AppCheckToken_native.set(this, void 0);
    }
    static fromNative(token) {
        if (token instanceof FIRAppCheckToken) {
            const t = new AppCheckToken();
            __classPrivateFieldSet(t, _AppCheckToken_native, token, "f");
            return t;
        }
        return null;
    }
    get native() {
        return __classPrivateFieldGet(this, _AppCheckToken_native, "f");
    }
    get ios() {
        return this.native;
    }
    get token() {
        var _a;
        return (_a = this.native) === null || _a === void 0 ? void 0 : _a.token;
    }
    get expireTimeMillis() {
        var _a, _b, _c;
        return (_c = (_b = (_a = this.native) === null || _a === void 0 ? void 0 : _a.expirationDate) === null || _b === void 0 ? void 0 : _b.getTime) === null || _c === void 0 ? void 0 : _c.call(_b);
    }
}
_AppCheckToken_native = new WeakMap();
var FIRAppCheckProviderFactoryImpl = /** @class */ (function (_super) {
    __extends(FIRAppCheckProviderFactoryImpl, _super);
    function FIRAppCheckProviderFactoryImpl() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    FIRAppCheckProviderFactoryImpl.prototype.createProviderWithApp = function (app) {
        var provider;
        if (parseFloat(Device.sdkVersion) > 14) {
            provider = FIRAppAttestProvider.alloc().initWithApp(app);
        }
        else {
            provider = FIRDeviceCheckProvider.alloc().initWithApp(app);
        }
        return provider;
    };
    FIRAppCheckProviderFactoryImpl = __decorate([
        ObjCClass(FIRAppCheckProviderFactory)
    ], FIRAppCheckProviderFactoryImpl);
    return FIRAppCheckProviderFactoryImpl;
}(NSObject));
var FIRAppCheckProviderImpl = /** @class */ (function (_super) {
    __extends(FIRAppCheckProviderImpl, _super);
    function FIRAppCheckProviderImpl() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _FIRAppCheckProviderImpl_owner.set(_this, void 0);
        _FIRAppCheckProviderImpl_queue.set(_this, void 0);
        return _this;
    }
    FIRAppCheckProviderImpl_1 = FIRAppCheckProviderImpl;
    FIRAppCheckProviderImpl.initWithOwner = function (owner) {
        var provider = FIRAppCheckProviderImpl_1.new();
        __classPrivateFieldSet(provider, _FIRAppCheckProviderImpl_owner, owner, "f");
        __classPrivateFieldSet(provider, _FIRAppCheckProviderImpl_queue, dispatch_queue_create('FIRAppCheckProviderImpl', null), "f");
        return provider;
    };
    FIRAppCheckProviderImpl.prototype.getTokenWithCompletion = function (handler) {
        var _this = this;
        dispatch_async(__classPrivateFieldGet(this, _FIRAppCheckProviderImpl_queue, "f"), function () {
            var _a, _b, _c, _d;
            var callback = function (token, error) {
                if (token) {
                    handler(FIRAppCheckToken.alloc().initWithTokenExpirationDate(token.token, token.expirationDate), null);
                }
                else {
                    handler(null, error.intoNative());
                }
            };
            (_d = (_b = (_a = __classPrivateFieldGet(_this, _FIRAppCheckProviderImpl_owner, "f")).get) === null || _b === void 0 ? void 0 : (_c = _b.call(_a)).getToken) === null || _d === void 0 ? void 0 : _d.call(_c, callback);
        });
    };
    var _FIRAppCheckProviderImpl_owner, _FIRAppCheckProviderImpl_queue;
    var FIRAppCheckProviderImpl_1;
    _FIRAppCheckProviderImpl_owner = new WeakMap(), _FIRAppCheckProviderImpl_queue = new WeakMap();
    FIRAppCheckProviderImpl = FIRAppCheckProviderImpl_1 = __decorate([
        ObjCClass(FIRAppCheckProvider)
    ], FIRAppCheckProviderImpl);
    return FIRAppCheckProviderImpl;
}(NSObject));
var FIRAppCheckProviderFactoryCustomImpl = /** @class */ (function (_super) {
    __extends(FIRAppCheckProviderFactoryCustomImpl, _super);
    function FIRAppCheckProviderFactoryCustomImpl() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _FIRAppCheckProviderFactoryCustomImpl_owner.set(_this, void 0);
        return _this;
    }
    FIRAppCheckProviderFactoryCustomImpl_1 = FIRAppCheckProviderFactoryCustomImpl;
    FIRAppCheckProviderFactoryCustomImpl.initWithOwner = function (owner) {
        var provider = FIRAppCheckProviderFactoryCustomImpl_1.new();
        __classPrivateFieldSet(provider, _FIRAppCheckProviderFactoryCustomImpl_owner, owner, "f");
        return provider;
    };
    FIRAppCheckProviderFactoryCustomImpl.prototype.createProviderWithApp = function (app) {
        var _a, _b, _c, _d, _e;
        return ((_e = (_d = (_c = (_b = (_a = __classPrivateFieldGet(this, _FIRAppCheckProviderFactoryCustomImpl_owner, "f")).get) === null || _b === void 0 ? void 0 : _b.call(_a)) === null || _c === void 0 ? void 0 : _c.createProvider) === null || _d === void 0 ? void 0 : _d.call(_c, FirebaseApp.fromNative(app))) === null || _e === void 0 ? void 0 : _e.native) || null;
    };
    var _FIRAppCheckProviderFactoryCustomImpl_owner;
    var FIRAppCheckProviderFactoryCustomImpl_1;
    _FIRAppCheckProviderFactoryCustomImpl_owner = new WeakMap();
    FIRAppCheckProviderFactoryCustomImpl = FIRAppCheckProviderFactoryCustomImpl_1 = __decorate([
        ObjCClass(FIRAppCheckProviderFactory)
    ], FIRAppCheckProviderFactoryCustomImpl);
    return FIRAppCheckProviderFactoryCustomImpl;
}(NSObject));
export class AppCheckProviderFactory {
    constructor() {
        _AppCheckProviderFactory_native.set(this, void 0);
        __classPrivateFieldSet(this, _AppCheckProviderFactory_native, FIRAppCheckProviderFactoryCustomImpl.initWithOwner(new WeakRef(this)), "f");
    }
    get native() {
        return __classPrivateFieldGet(this, _AppCheckProviderFactory_native, "f");
    }
}
_AppCheckProviderFactory_native = new WeakMap();
export class AppCheckProvider {
    constructor() {
        _AppCheckProvider_native.set(this, void 0);
        __classPrivateFieldSet(this, _AppCheckProvider_native, FIRAppCheckProviderImpl.initWithOwner(new WeakRef(this)), "f");
    }
    get native() {
        return __classPrivateFieldGet(this, _AppCheckProvider_native, "f");
    }
}
_AppCheckProvider_native = new WeakMap();
let provider;
let customProvider;
export class AppCheck {
    constructor(app) {
        _AppCheck_native.set(this, void 0);
        _AppCheck_nativeApp.set(this, void 0);
        _AppCheck_app.set(this, void 0);
        if (app === null || app === void 0 ? void 0 : app.native) {
            __classPrivateFieldSet(this, _AppCheck_native, FIRAppCheck.appCheckWithApp(app.native), "f");
            __classPrivateFieldSet(this, _AppCheck_nativeApp, app.native, "f");
        }
        else {
            if (defaultAppCheck) {
                return defaultAppCheck;
            }
            defaultAppCheck = this;
            const app = FIRApp.defaultApp();
            __classPrivateFieldSet(this, _AppCheck_native, FIRAppCheck.appCheckWithApp(app), "f");
            __classPrivateFieldSet(this, _AppCheck_nativeApp, app, "f");
        }
    }
    static setProviderFactory(custom) {
        if (custom && custom instanceof AppCheckProviderFactory) {
            customProvider = custom;
            FIRAppCheck.setAppCheckProviderFactory(custom.native);
        }
        else {
            if (!provider) {
                provider = FIRAppCheckProviderFactoryImpl.alloc().init();
            }
            customProvider = undefined;
            FIRAppCheck.setAppCheckProviderFactory(provider);
        }
    }
    activate(isTokenAutoRefreshEnabled) {
        this.native.isTokenAutoRefreshEnabled = isTokenAutoRefreshEnabled;
    }
    getToken(forceRefresh) {
        return new Promise((resolve, reject) => {
            this.native.tokenForcingRefreshCompletion(forceRefresh, (token, error) => {
                if (error) {
                    const err = FirebaseError.fromNative(error);
                    reject(err);
                }
                else {
                    resolve(AppCheckToken.fromNative(token));
                }
            });
        });
    }
    setTokenAutoRefreshEnabled(enabled) {
        this.native.isTokenAutoRefreshEnabled = enabled;
    }
    get native() {
        return __classPrivateFieldGet(this, _AppCheck_native, "f");
    }
    get ios() {
        return this.native;
    }
    get app() {
        if (!__classPrivateFieldGet(this, _AppCheck_app, "f")) {
            // @ts-ignore
            __classPrivateFieldSet(this, _AppCheck_app, FirebaseApp.fromNative(__classPrivateFieldGet(this, _AppCheck_nativeApp, "f")), "f");
        }
        return __classPrivateFieldGet(this, _AppCheck_app, "f");
    }
}
_AppCheck_native = new WeakMap(), _AppCheck_nativeApp = new WeakMap(), _AppCheck_app = new WeakMap();
//# sourceMappingURL=index.ios.js.map